--- old/gcc/config/i386/i386.c	2012-10-28 20:56:07.266758790 -0400
+++ new/gcc/config/i386/i386.c	2012-10-28 20:56:07.282330524 -0400
@@ -4403,6 +4403,7 @@
   if (decl
       && TREE_CODE (decl) == FUNCTION_DECL
       && optimize
+      && (TARGET_64BIT || !flag_strict_calling_conventions)
       && !profile_flag)
     {
       /* FIXME: remove this CONST_CAST when cgraph.[ch] is constified.  */
@@ -4487,7 +4488,8 @@
 
   /* For local functions, pass up to SSE_REGPARM_MAX SFmode
      (and DFmode for SSE2) arguments in SSE registers.  */
-  if (decl && TARGET_SSE_MATH && optimize && !profile_flag)
+  if (decl && TARGET_SSE_MATH && optimize && !profile_flag &&
+    (TARGET_64BIT || !flag_strict_calling_conventions))
     {
       /* FIXME: remove this CONST_CAST when cgraph.[ch] is constified.  */
       struct cgraph_local_info *i = cgraph_local_info (CONST_CAST_TREE(decl));
